<?php
/**
 * Provides a special function to invoke a page with dynamic parameters being passed
 *
 * @author Algorithmix (Gero Scholz) http://semeb.com/dpldemo

 * @version 0.1
 */

class Call extends SpecialPage
{
        function Call() {
                SpecialPage::SpecialPage("Call");
                self::loadMessages();
        }

        
		function execute($par) {
		    global $wgOut, $wgRequest, $wgRawHtml, $wgUser;
		    $oldRawHtml = $wgRawHtml;
		    $wgRawHtml = false;         // disable raw html if it's enabled as this could be XSS security risk
            $this->setHeaders();
            		 
            global $_REQUEST;
       		$numargs=0;
       		$argkeys = array_keys($_REQUEST);
       		foreach ($argkeys as $argkey) {
	       		if (strpos($argkey,'UserName') ===false) ++$numargs;
	       		else break;
       		}	

       		$wikitext='';

       		for ($i=0; $i<$numargs; $i++)  {
	       		if ($i==0) {
		       		$wikitext .= preg_replace(',^[^/]+/,','',$wgRequest->getText($argkeys[$i]),1);
		   			$wikitext = str_replace( ",", "|", $wikitext );
					$wikitext = str_replace( "_", " ", $wikitext );
		       		continue;
	       		}
	       		$arg = $wgRequest->getText($argkeys[$i]);
		       	if ($arg=='') {
			       	$arg = str_replace( "_", " ", $argkeys[$i] );
					$wikitext .= ( '|' . $arg );
		       	} else {
			       	$arg = str_replace( "_", " ", $arg );
					$wikitext .= ( '|' . $argkeys[$i] . '=' . $arg );
				}
       		}
       		
       		if ($wikitext=='' && $par!='') {
	       		// the first argument may contain parameters which are separated by comma
	       		// this is the case if [[Call,a=b]] syntax is used
	   			$wikitext = str_replace( ",", "|", $par );
				$wikitext = str_replace( "_", " ", $wikitext );
       		}
            
	        $wgOut->addHtml($wgOut->parse("{{".$wikitext."}}"));
            $skin = $wgUser->getSkin();
		 
		    $wgRawHtml = $oldRawHtml;

		    $newTitle = split("\,",$par,2);
		    if ($newTitle!=null && strlen($newTitle[0])>0) {
			    $newTitle[0]=str_replace("_"," ",$newTitle[0]);
			    $newTitle[0]=preg_replace("/^:/","",$newTitle[0]);
   				$wgOut->setPageTitle($newTitle[0]);
			}
  			// $wgOut->addMeta("http:expires", "0");
  
		}


        function loadMessages() {
                static $messagesLoaded = false;
                global $wgMessageCache;
                if ( $messagesLoaded ) return;
                $messagesLoaded = true;

                require( dirname( __FILE__ ) . '/Call.i18n.php' );
                foreach ( $allMessages as $lang => $langMessages ) {
                        $wgMessageCache->addMessages( $langMessages, $lang );
                }
        }
}
?>